###############################################################################
# SeemlySmiliesSet.pm                                                         #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.6.0                                                  #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2014 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
###############################################################################
# Written by Zoo, updated to 2.6.0 by D.A. Rorabaugh (Dandello)               #
###############################################################################
use CGI qw(:standard);
use CGI::Carp qw(fatalsToBrowser);
use Time::Local;
use File::stat;
our $VERSION = '2.6.0';

$seemlysmiliessetpmver = 'YaBB 2.6.0 $Revision: 0.1 $';
if ( $action eq 'detailedversion' ) { return 1; }

my $seemlydirs = qq~$htmldir/ModImages/Seemly~;
my $seemlydir  = $imagesdir;
my $seemlyurl  = qq~$yyhtml_root/ModImages/Seemly~;
my @days       = ( 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 );
my @days2      = ( 0, 31, 60, 91, 121, 152, 182, 213, 244, 274, 305, 335 );
my @smiliename =
  qw(smiley wink cheesy grin angry sad shocked cool huh rolleyes tongue embarassed lipsrsealed undecided kiss cry laugh);
my ($smon, $sday, $sday1, $sname, $other, $i );
my ($ok, $from, $to, $fromm, $fromd, $tom, $tod, $ssetdir);
my (@sdir, @seemlysetting, @seemlysetting1);

sub SeemlySet {
    is_admin();
    $fromm        = $INFO{'fm'}           || $mon_num;
    $fromd        = $INFO{'fd'}           || 1;
    $tom          = $INFO{'tm'}           || $mon_num;
    $tod          = $INFO{'td'}           || $days[ $mon_num - 1 ];
    $seemlyaction = $INFO{'seemlyaction'} || 'view';
    $ssetdir      = $INFO{'ssetdir'}      || q{};

####### SeemlyDateCheck
    $ok = 1;
    if    ( $fromm < 1 || $fromm > 12 )                  { $ok = 0; }
    elsif ( $fromd < 1 || $fromd > $days[ $fromm - 1 ] ) { $ok = 0; }
    elsif ( $tom < 1   || $tom > 12 )                    { $ok = 0; }
    elsif ( $tod < 1   || $tod > $days[ $tom - 1 ] )     { $ok = 0; }
    elsif ( $tom < $fromm ) { $tom = $fromm; $tod = $fromd; }
    elsif ( $tom == $fromm && $tod < $fromd ) { $tod = $fromd; }

    if ( !$ok ) {
        $fromm = $mon_num;
        $fromd = 1;
        $tom   = $mon_num;
        $tod   = $days[ $mon_num - 1 ];
    }

    $from = $days2[ $fromm - 1 ] + $fromd - 1;
    $to   = $days2[ $tom - 1 ] + $tod - 1;
####### END SeemlyDateCheck

####### SeemlyRebuild
    is_admin();
    if ( !-e "$vardir/seemlysmilies.txt" ) {    # no seemlysmilies file
        my $daycount = 0;
        for my $smon ( 1 .. 12 ) {
            if ( $smon < 10 ) { $smon = "0$smon"; }
            for my $sday ( 1 .. $days[ $smon - 1 ] ) {
                $sday1 = $sday;
                if ( $sday < 10 ) { $sday1 = "0$sday"; }
                $seemlysetting[$daycount] = "$smon/$sday1//";
                $daycount++;
            }
        }
        fopen( FILE, ">$vardir/seemlysmilies.txt", 1 );
        for my $i ( 0 .. 365 ) {
            print {FILE} "$seemlysetting[$i]\n" or croak "$croak{'print'} Seemly Smiles";
        }
        fclose(FILE);
    }
    else {
        fopen( FILE, "$vardir/seemlysmilies.txt" );
        @seemlysetting = <FILE>;
        $seemlycount   = @seemlysetting;
        fclose(FILE);
        if ( $seemlycount != 366 ) {    # seemlysmilies record less days of year
            @seemlysetting1 = @seemlysetting;
            my $daycount = 0;
            for my $smon ( 1 .. 12 ) {
                if ( $smon < 10 ) { $smon = "0$smon"; }
                for my $sday ( 1 .. $days[ $smon - 1 ] ) {
                    $sday1 = $sday;
                    if ( $sday < 10 ) { $sday1 = "0$sday"; }
                    $seemlysetting[$daycount] = "$smon/$sday1/";
                    for my $curseemly (@seemlysetting1)
                    {                   # save previous settings
                        chomp $curseemly;
                        ( $old_smon, $old_sday, $old_sname, $other ) =
                          split /\//xsm, $curseemly;
                        if ( ( $old_smon == $smon ) & ( $old_sday == $sday1 ) )
                        {
                            $seemlysetting[$daycount] =
                              "$seemlysetting[$daycount]$old_sname";
                            last;
                        }
                    }
                    $daycount++;
                }
            }

            if ( -e "$vardir/seemlysmilies.txt" ) {
                unlink "$vardir/seemlysmilies.txt";
            }
            fopen( FILE, ">$vardir/seemlysmilies.txt", 1 );
            for my $i ( 0 .. 365 ) {
                print {FILE} "$seemlysetting[$i]/\n" or croak "$croak{'print'} Seemly Smiles";
            }
            fclose(FILE);
        }
    }
####### END SeemlyRebuild

####### SeemlyDirs
    opendir DIR, "$seemlydirs" or croak "Not found seemlydirs! $seemlydirs";
    @files = grep {!/^\.\.?$/xsm} readdir DIR;
    closedir DIR;
    $dircount = 1;
    for my $file (@files) {
        if ( -d "$seemlydirs/$file" ) {
            $ok = 0;
            for my $i ( 0 .. 16 ) {
                if ( -e "$seemlydirs/$file/$smiliename[$i].gif" ) {
                    $ok = 1;
                    last;
                }
            }
            if ($ok) { $sdir[$dircount] = $file; $dircount++; }
        }
    }
    $sdir[0] = q{          };
    @sdir    = sort @sdir;
    $sdir[0] = "$ssmtxt{'4'}";
####### END SeemlyDirs

####### SeemlyHead
    for my $i ( 1 .. 12 ) {
        my $sel  = q{};
        my $selt = q{};
        if ( $fromm == $i ) {
            $sel = ' selected="selected"';
        }
        $boxmonths_inner .=
            q~      <option value="~
          . sprintf( '%02d', $i )
          . qq~"$sel>$i</option>\n~;

        if ( $tom == $i ) {
            $selt = ' selected="selected"';
        }
        $boxmonths_inner2 .=
            q~      <option value="~
          . sprintf( '%02d', $i )
          . qq~"$selt>$i</option>\n~;
    }
    for my $i ( 1 .. 31 ) {
        my $sel  = q{};
        my $seld = q{};
        if ( $fromd == $i ) {
            $sel = ' selected="selected"';
        }
        if ( $tod == $i ) {
            $seld = ' selected="selected"';
        }
        $boxdays_inner .=
            q~      <option value="~
          . sprintf( '%02d', $i )
          . qq~"$sel>$i</option>\n~;
        $boxdays_inner2 .=
            q~      <option value="~
          . sprintf( '%02d', $i )
          . qq~"$seld>$i</option>\n~;
    }
    $yymain .= qq~
    <div class="bordercolor rightboxdiv">
    <form action="$adminurl?action=seemlyset2" method="post">
    <table class="border-space pad-cell" style="margin-bottom: .5em;">
        <tr>
            <th class="titlebg">&nbsp;<img src="$imagesdir/grin.gif"></th>
            <th class="titlebg right" style="width:10%">$ssmtxt{'2'}</th>
            <th class="titlebg center" style="width:auto">
            <label for="fromm"><span class="small">$ssmtxt{'mon'}</span></label>
                <select class="input" name="fromm" id="fromm">
                $boxmonths_inner
                </select> /
                <label for="fromd"><span class="small">$ssmtxt{'day'}</span></label>
                <select class="input" name="fromd" id="fromd">
                    <option value="0">---</option>
                    $boxdays_inner
                </select> $ssmtxt{'to'}
                <label for="tom"><span class="small">$ssmtxt{'mon'}</span></label>
                <select class="input" name="tom" id="tom">
                $boxmonths_inner2
                </select> /
                <label for="tod"><span class="small">$ssmtxt{'day'}</span></label>
                <select class="input" name="tod" id="tod">
                    <option value="0">---</option>
                    $boxdays_inner2
                </select>
            </th>
            <th class="titlebg center" style="width:20%">$ssmtxt{'sets'}:
                <select name='ssetdir'>
                ~;
    for my $i ( 0 .. ( $dircount - 1 ) ) {
        $yymain .= qq~
                    <option value=$i>$sdir[$i]
~;
    }
    $yymain .= qq~
                </select>
            </th>
            <th class="titlebg center" style="width:20%">$ssmtxt{'act'}:
                <select name='saction'>
                    <option value=1>$ssmtxt{'5'}
                    <option value=2>$ssmtxt{'6'}
                    <option value=3>$ssmtxt{'7'}
                    <option value=4>$ssmtxt{'8'}
                    <option value=5>$ssmtxt{'9'}
                </select>
            </th>
            <th class="titlebg center" style="width:15%">
                <input type=submit value=$ssmtxt{'3'}>
            </th>
        </tr>
    </table>
    </form>
    </div>
~;
####### END SeemlyHead

####### SeemlyView
    $seemlyact = ucfirst $seemlyaction;
    $seemlyact =~ s/_/\ /gsm;
    $yymain .= qq~
    <div class="bordercolor rightboxdiv">
    <table class="border-space pad-cell" style="margin-bottom: .5em;">
        <tr>
            <td class="titlebg" colspan="19" style="padding-left:1%">$seemlyact</td>
        </tr>~;

    if ( $seemlyaction eq 'collections' ) {
        $yymain .= qq~<tr>
        <td class='windowbg2 center' style="width:15%"> <b>$sdir[0]</b> </td>~;
        for my $j ( 0 .. 16 ) {
            $smileout = "$imagesdir/$smiliename[$j].gif";
            $yymain .=
qq~         <td class="windowbg2 center" style="width:5%"><img src='$smileout' alt='$smiliename[$j]'></td>~;
        }
        $yymain .= q~       </tr>~;
        for my $i ( 1 .. ( $dircount - 1 ) ) {
            $yymain .= qq~<tr>
            <td class='windowbg2 center' style="width:15%"> <b>$sdir[$i]</b> </td>~;
            for my $j ( 0 .. 16 ) {
                if ( !-e "$seemlydirs/$sdir[$i]/$smiliename[$j].gif" ) {
                    $smileout  = "$yyhtml_root/ModImages/nosmilie.gif";
                    $smiliealt = 'NOT FOUND SMILIE! - ';
                }
                else {
                    $smileout  = "$seemlyurl/$sdir[$i]/$smiliename[$j].gif";
                    $smiliealt = q{};
                }
                $yymain .=
qq~          <td class='windowbg2 center' style="width:5%"><img src='$smileout' alt='$smiliealt$smiliename[$j]'></td>~;
            }
            $yymain .= q~       </tr>~;
        }
    }
    else {
        if ( $seemlyaction eq 'dayset' ) {
            @seemlysetting2 = @seemlysetting;
            for my $i ( $from .. $to ) {
                ( $smon, $sday, $sname, $other ) = split /\//xsm,
                  $seemlysetting[$i], 4;
                if   ( $ssetdir == 0 ) { $sname = q{}; }
                else                   { $sname = $sdir[$ssetdir]; }
                $seemlysetting[$i] = "$smon/$sday/$sname/\n";
            }
            if ( -e "$vardir/seemlysmilies.txt" ) {
                unlink "$vardir/seemlysmilies.txt";
            }
            fopen( FILE, ">$vardir/seemlysmilies.txt", 1 );
            for my $i ( 0 .. 365 ) {
                print {FILE} "$seemlysetting[$i]" or croak "$croak{'print'} Seemly Smiles";
            }
            fclose(FILE);
        }

        for my $i ( $from .. $to ) {
            ( $smon[$i], $sday[$i], $sname[$i], $other ) =
              split  /\//xsm, $seemlysetting[$i], 4;
            if   ( $sname[$i] ne q{} ) { $seemlydir = "$seemlyurl/$sname[$i]"; }
            else                       { $seemlydir = $imagesdir; }

            if ( $seemlyaction eq 'view' || $seemlyaction eq 'dayset' ) {
                $yymain .= qq~
        <tr>
            <td class='windowbg2 center' style="width:4%"> $smon[$i]/$sday[$i] </td>
            <td class='windowbg2 center' style="width:11%"> <b>$sname[$i]</b> </td> ~;
                for my $j ( 0 .. 16 ) {
                    if ( $sname[$i] ne q{} ) {
                        if ( !-e "$seemlydirs/$sname[$i]/$smiliename[$j].gif" )
                        {
                            $smileout  = "$yyhtml_root/ModImages/nosmilie.gif";
                            $smiliealt = "NOT FOUND SMILIE! $sname[$i]/";
                        }
                        else {
                            $smileout  = "$seemlydir/$smiliename[$j].gif";
                            $smiliealt = q{};
                        }
                    }
                    else {
                        $smileout  = "$seemlydir/$smiliename[$j].gif";
                        $smiliealt = $ssmtxt{'4'};
                    }
                    $yymain .=
qq~             <td class='windowbg2 center' style="width:5%"><img src='$smileout' alt='$smiliealt$smiliename[$j]'></td>~;
                }
                $yymain .= q~</tr>~;
            }
            elsif ( $seemlyaction eq 'view_set_days' ) {
                if ( $sname[$i] ne q{} ) {
                    $yymain .= qq~
            <tr>
                <td class='windowbg2 center' style="width:4%"> $smon[$i]/$sday[$i] </td>
                <td class='windowbg2 center' style="width:11"> <b>$sname[$i]</b> </td>~;
                    for my $j ( 0 .. 16 ) {
                        if ( !-e "$seemlydirs/$sname[$i]/$smiliename[$j].gif" )
                        {
                            $smileout  = "$yyhtml_root/ModImages/nosmilie.gif";
                            $smiliealt = "NOT FOUND SMILIE! $sname[$i]/";
                        }
                        else {
                            $smileout  = "$seemlydir/$smiliename[$j].gif";
                            $smiliealt = q{};
                        }
                        $yymain .=
qq~<td class='windowbg2 center' style="width:5%"><img src='$smileout' alt='$smiliealt$smiliename[$j]'></td>~;
                    }
                    $yymain .= q~</tr>~;
                }
            }
            elsif ( $seemlyaction eq 'error' ) {
                if ( $sname[$i] ne q{} ) {
                    $founderror = 0;
                    for my $j ( 0 .. 16 ) {
                        if ( !-e "$seemlydirs/$sname[$i]/$smiliename[$j].gif" )
                        {
                            $founderror = 1;
                            last;
                        }
                    }
                    if ( $founderror == 1 ) {
                        $yymain .= qq~<tr>
            <td class='windowbg2 center' style="width:4%"> $smon[$i]/$sday[$i] </td>
              <td class='windowbg2 center' style="width:11%"> <b>$sname[$i]</b> </td>~;
                        for my $j ( 0 .. 16 ) {
                            if (
                                !-e "$seemlydirs/$sname[$i]/$smiliename[$j].gif"
                              )
                            {
                                $smileout =
                                  "$yyhtml_root/ModImages/nosmilie.gif";
                                $smiliealt = "NOT FOUND SMILIE! $sname[$i]/";
                            }
                            else {
                                $smileout  = "$seemlydir/$smiliename[$j].gif";
                                $smiliealt = q{};
                            }
                            $yymain .=
qq~<td class='windowbg2 center' style="width:4%"'><img src='$smileout' alt='$smiliealt$smiliename[$j]'></td>~;
                        }
                        $yymain .= q~</tr>~;
                    }
                }
            }
        }
    }
    $yymain .= q~
    </table>
    </div>
    ~;
####### END SeemlyView

    $yytitle = "$ssmtxt{'1'}";
    AdminTemplate();
    exit;
}

sub SeemlySet2 {
    is_admin();
    $fromm   = $FORM{'fromm'};
    $fromd   = $FORM{'fromd'};
    $tom     = $FORM{'tom'};
    $tod     = $FORM{'tod'};
    $saction = $FORM{'saction'};
    $ssetdir = $FORM{'ssetdir'};

####### SeemlyDateCheck
    $ok = 1;
    if    ( $fromm < 1 || $fromm > 12 )                  { $ok = 0; }
    elsif ( $fromd < 1 || $fromd > $days[ $fromm - 1 ] ) { $ok = 0; }
    elsif ( $tom < 1   || $tom > 12 )                    { $ok = 0; }
    elsif ( $tod < 1   || $tod > $days[ $tom - 1 ] )     { $ok = 0; }
    elsif ( $tom < $fromm ) { $tom = $fromm; $tod = $fromd; }
    elsif ( $tom == $fromm && $tod < $fromd ) { $tod = $fromd; }

    if ( !$ok ) {
        $fromm = $mon_num;
        $fromd = 1;
        $tom   = $mon_num;
        $tod   = $days[ $mon_num - 1 ];
    }

    $from = $days2[ $fromm - 1 ] + $fromd - 1;
    $to   = $days2[ $tom - 1 ] + $tod - 1;
####### END SeemlyDateCheck

    $yySetLocation =
"$adminurl?action=seemlyset;fm=$fromm;fd=$fromd;tm=$tom;td=$tod;seemlyaction=view";
    if ( $saction == 2 ) {
        $yySetLocation =
"$adminurl?action=seemlyset;fm=$fromm;fd=$fromd;tm=$tom;td=$tod;seemlyaction=view_set_days";
    }
    elsif ( $saction == 3 ) {
        $yySetLocation =
"$adminurl?action=seemlyset;fm=$fromm;fd=$fromd;tm=$tom;td=$tod;seemlyaction=collections";
    }
    elsif ( $ok && $saction == 4 ) {
        $yySetLocation =
"$adminurl?action=seemlyset;fm=$fromm;fd=$fromd;tm=$tom;td=$tod;seemlyaction=dayset;ssetdir=$ssetdir";
    }
    elsif ( $saction == 5 ) {
        $yySetLocation =
          "$adminurl?action=seemlyset;fm=1;fd=1;tm=12;td=31;seemlyaction=error";
    }
    redirectexit();
}

1;
